// Nathan E. Moore
// April 11, 2004

#pragma once
#include "parser.h"
#include "menu.h"
#include <windows.h>
#include "globals.h"
#include <boost/noncopyable.hpp>

class PrefixedRCString;
class MenuBuilder;

ParserPtr createRemoteAmp(const std::wstring& label = G_REMOTEAMP);

class MenuSettings : public boost::noncopyable
{
private:
	std::wstring m_hotlist;

	// is the next element to start a newColumn
	bool m_column;

	// loads any settings
	void settings(PrefixedRCString& prefix);

	// Step RC parsing worker methods
	void parseStepRC(PrefixedRCString& prefix, Menu& menu);
	void parseFolder(PrefixedRCString& prefix, FILE *pStepRC, MenuBuilder& builder);
	bool parseLine(PrefixedRCString& prefix, FILE *pStepRC, MenuBuilder& builder, char* line);
	ParserPtr makeBangItem(const char* item, const std::wstring& title) const;
	ParserPtr makeBangItem(const char* item) const;

	void setColumn()
	{
		m_column = true;
	}

	bool getColumn()
	{
		bool rval = m_column;
		m_column = false;
		return rval;
	}

	void configure(Menu& menu);

public:
	MenuSettings(Menu& menu)
			: m_column(false)
	{
		configure(menu);
	}
};
