// Nathan E. Moore
// April 11, 2004

#include "common.h"

#define ERR_STR_1 "Error #"
#define ERR_STR_2 ": "

std::ostream& operator<<(std::ostream& os, const WinErrorMsg& wem)
{
	char* errstr = NULL;
	FormatMessageA(
	    FORMAT_MESSAGE_ALLOCATE_BUFFER |
	    FORMAT_MESSAGE_FROM_SYSTEM,
	    NULL,
	    wem.m_error,
	    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),  // Default language
	    errstr,
	    0,
	    NULL
	);

	os << ERR_STR_1 << wem.m_error << ERR_STR_2;

	if (errstr) // if FormatMessage fails errstr is NULL
	{
		os << errstr;
		LocalFree(errstr);
	}
	return os;
}

std::wostream& operator<<(std::wostream& wos, const WinErrorMsg& wem)
{
	wchar_t* errstr = NULL;
	FormatMessageW(
	    FORMAT_MESSAGE_ALLOCATE_BUFFER |
	    FORMAT_MESSAGE_FROM_SYSTEM,
	    NULL,
	    wem.m_error,
	    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),  // Default language
	    errstr,
	    0,
	    NULL
	);

	wos << WSTR(ERR_STR_1) << wem.m_error << WSTR(ERR_STR_2);

	if (errstr) // if FormatMessage fails errstr is NULL
	{
		wos << errstr;
		LocalFree(errstr);
	}
	return wos;
}