// Nathan E. Moore
// April 8, 2004
// All of this stuff was pulled from menu

#pragma once

#define NOVTABLE __declspec(novtable)
#define WSTR2(x) L ## x
#define WSTR(x) WSTR2(x)
#define STR2(x) #x
#define STR(x) STR2(x)

#define LOCATION "[" __FILE__ ", " STR(__LINE__) "]"
#define WLOCATION L"[" WSTR(__FILE__) L", " WSTR(STR(__LINE__)) L"]"
#define ERR_MSG(x) x " " LOCATION

// Debug logging
#ifndef NDEBUG
#	include "debugstream.h"
static util::debugout g_debughidden;
static util::wdebugout g_wdebughidden;
// use these macros or your release builds will fail.
#	define DEBUG_OUT(iostr) g_debughidden << iostr << " " LOCATION << std::endl
#	define DEBUG_WOUT(iostr) g_wdebughidden << iostr << L" " WLOCATION << std::endl
#else
#	define DEBUG_OUT(iostr) 0
#	define DEBUG_WOUT(iostr) 0
#endif

#include <ostream>
#include <windows.h>	// For DWORD

class WinErrorMsg
{
private:
	DWORD m_error;
public:
	explicit WinErrorMsg(DWORD error)
			:m_error(error)
	{}

	WinErrorMsg()
		:m_error(GetLastError())
	{}

	// this could be a template but I don't see the point. I would still have
	// to write two functions.
	friend std::ostream& operator<<(std::ostream& os, const WinErrorMsg& wem);
	friend std::wostream& operator<<(std::wostream& wos, const WinErrorMsg& wem);
};
